(define (domain brownies)

	(:types
		take1 put1 open1 close1 takeput2 turn_on1 ctake1 cput twoobjects fill1 fill2 fill3 - object
		take2 put2  - takeput2
		twoobjects - object
		walkl - object
		part - object
		openp1 - open1
		copen1 - take1
		cofill2 - fill2
		cfill1 - object
	)
	
	(:predicates
		(is-open ?what - object)
	)
	
	(:constants
		measuring_cup_s&measuring_cup_l butter_spray_can&oil_bottle oil_bottle&oil_bottle_cap  oil_bottle&measuring_cup_s brownie_box&brownie_bag baking_pan&bowl brownie_box&whisk fork&spoon - twoobjects
		cupboard_tr cupboard_tl cupboard_br cupboard_tm fridge oven egg_box brownie_box drawer egg_shell cupboard_bl oil_bottle butter_spray_can garbage - open1
		brownie_bag brownie_box croutons_bag oven drawer - openp1
		cupboard_tr cupboard_tl cupboard_br cupboard_tm fridge oven egg_box drawer cupboard_bl oil_bottle butter_spray_can garbage - close1
		bowl brownie_box oil_bottle butter_spray_can towel egg_box measuring_cup_s baking_pan measuring_cup_l fork brownie_bag knife whisk oil_bottle_cap butter_spray_cap scissors  spoon croutons_bag spatula board - take1
		cupboard_tr cupboard_tl cupboard_br cupboard_tm cupboard_bl hands counter fridge egg_box oven drawer brownie_box sink oil_bottle bowl butter_spray_can brownie_bag baking_pan garbage measuring_cup_l board fridge_counter - take2
		bowl butter_spray_can oil_bottle brownie_box measuring_cup_s baking_pan measuring_cup_l egg_box towel fork knife brownie_bag whisk oil_bottle_cap whisk scissors butter_spray_cap spoon croutons_bag spatula board - put1
		counter drawer sink cupboard_bl cupboard_tr cupboard_br bowl brownie_box oven fridge baking_pan garbage measuring_cup_l board fridge_counter - put2
		counter_place fridge_place - walkl
		oven - turn_on1
		egg_shell egg open_egg_shell empty_egg_shell paper_towel - ctake1
		egg_shell empty_egg_shell paper_towel - cput1
		egg_shell - copen1
		water brownie_mix egg oil butter dough - fill1
		brownie_mix butter water oil dough - pfill1
		tap measuring_cup_l measuring_cup_s brownie_bag egg_shell oil_bottle butter_spray_can bowl - fill2
		measuring_cup_l bowl measuring_cup_s baking_pan - fill3	
		open_egg_shell - cofill2
		egg - cfill1 
		hands bowl spoon - clean1
		paper_towel towel water - clean2
		bowl - stir1
		whisk fork spoon - stir2
		butter_spray_can baking_pan - shake1
		partially - part
	)
	
	 (:functions
	 	(is-at ?w - take1) - takeput2
		(at) - walkl
		(objects_taken) - (number 3)
		(is-at-num ?what - ctake1 ?where - take2) - (number 2)
		(in-num ?what - cfill1 ?where - fill3) - (number 2)
		(shaken ?s - shake1) - (number 3)
	)
	
	(:action open
		:parameters (?what - open1)
;		:duration (open (objectId ?what))
		:precondition (and 
			(not (is-open ?what))
			(iff (= (at) fridge_place) (or 
										(= ?what fridge)
										(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
										)
			)
			(imply (or (= ?what oil_bottle)(= ?what butter_spray_can)) (<= (objects_taken) 2)))
		:effect (and 
				(is-open ?what)
				(when (= ?what oil_bottle) (and
					(assign (is-at oil_bottle_cap) hands)
					(increase (objects_taken) 1)
					))
				(when (= ?what butter_spray_can) (and
					(assign (is-at butter_spray_cap) hands)
					(increase (objects_taken) 1)
					))
				)
      ; :observation (set_action (actionId open))
	)
	
	(:action open
		:parameters (?what - copen1)
      ; :duration (open (objectId ?what))
		:precondition (and 
			(>= (is-at-num ?what hands) 1)
			)
		:effect ( and 
			(decrease (is-at-num ?what hands) 1)
			(increase (is-at-num (open-of ?what) hands) 1)
		)
		; :observation (set_action (actionId open))
		)
	
	; this action is usually taken while fiddling around with the packaging
	(:action open
		:irrational
		:parameters (?what - openp1 ?how - part)
		; :duration (open (objectId ?what))
		:precondition (and 
			(not (is-open ?what))
			(iff (= (at) fridge_place) (or 
										(= ?what fridge)
										(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
										)
			))
		:effect (and)
		; :observation (set_action (actionId open))
	)
		
	(:action close
		:parameters (?what - close1)
		; :duration (close (objectId ?what))
		:precondition (and 
				(is-open ?what)
				(imply (= ?what oil_bottle) (= (is-at oil_bottle_cap) hands))
				(imply (= ?what butter_spray_can) (= (is-at butter_spray_cap) hands))
				(iff (= (at) fridge_place) (or 
											(= ?what fridge)
											(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?what)))
											)
				))
		:effect (and
			(not (is-open ?what))
			(when (= ?what oil_bottle) (and 
				(decrease (objects_taken) 1)
				(assign (is-at oil_bottle_cap) oil_bottle)
				))
			(when (= ?what butter_spray_can) (and 
				(decrease (objects_taken) 1)
				(assign (is-at butter_spray_cap) butter_spray_can)
				))
			
			)
		; :observation (set_action (actionId close))
	)
	
	 (:action take
	 	:parameters (?what - take1 ?from - take2)
 		; :duration (take (objectId ?what) (objectId ?from))
	 	:precondition (and 
						(take-pair ?what ?from)
						(not (= ?what ?from))
						(= (is-at ?what) ?from)
						(not (= ?from hands))
						(or
							(and (= brownie_box ?from) (= brownie_box_rip ?what))
							(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
						)
						(iff (= (at) fridge_place) (or (= ?from fridge) (= ?from fridge_counter)))
						(<= (objects_taken) 2)
				 	 )
		:effect (and 
			(assign (is-at ?what) hands)
			(increase (objects_taken) 1)
			(when (not (is-clean ?what)) (not (is-clean hands)))
			)
		; :observation (set_action (actionId take))
	 )
	 
	 (:action take
	 	:parameters (?what - twoobjects ?from - take2)
 		; :duration (take (objectId (first ?what)) (objectId ?from))
	 	:precondition (and 
			(take-pair ?what ?from)
						(= (is-at (first ?what)) ?from)
						(= (is-at (second ?what)) ?from)
						(not (= ?from hands))
						(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
						(iff (= (at) fridge_place) (or (= ?from fridge) (= ?from fridge_counter)))
						(<= (objects_taken) 1)
				 	 )
		:effect (and 
			(assign (is-at (first ?what)) hands)
			(assign (is-at (second ?what)) hands)
			(increase (objects_taken) 2)
			)
		; :observation (set_action (actionId take))
	 )
	 
	 (:action take
		 :parameters (?howmany - (number 1 2) ?what - ctake1 ?from - take2)
		 ; :duration (take (objectId ?what) (objectId ?from))
		 :precondition (and 
			 (take-pair ?what ?from)
			 (not (= ?what ?from))
			 (>= (is-at-num ?what ?from) ?howmany)
			(not (= ?from hands))
			(imply (exists (?o - open1) (= ?from ?o)) (is-open ?from))
			(iff (= (at) fridge_place) (or 
							(= ?from fridge)
                     (= ?from fridge_counter)
							(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?from)))
							)
						)
			(<= (objects_taken) (- 3 ?howmany))
			 )
		 :effect (and
			 (decrease (is-at-num ?what ?from) ?howmany)
			 (increase (is-at-num ?what hands) ?howmany)
			 (increase (objects_taken) ?howmany)
			 )
			 ;TODO: check if we need the number of objects here
		 ; :observation (set_action (actionId take))
		)
	 
	 (:action put
		 :parameters (?what - put1 ?to - put2)
		 ; :duration (put (objectId ?what)(objectId ?to))
		 :precondition (and 
			(take-pair ?what ?to)
			 (not (= ?what ?to))
			(= (is-at ?what) hands)
			(imply (exists (?o - open1) (= ?to ?o)) (is-open ?to))
			(iff (= (at) fridge_place) (or (= ?to fridge) (= ?to fridge_counter)))
			)
		 :effect (and 
		 		(assign (is-at ?what) ?to)
				(decrease (objects_taken) 1)
				)
		; :observation (set_action (actionId put))
	)

 	(:action put
 			:parameters (?what - twoobjects ?to - put2)
			;TODO: check for second part of ?what
			; :duration (put (objectId (first ?what))(objectId ?to))
 			:precondition (and
				(take-pair ?what ?to)
 				(= (is-at (first ?what)) hands)
 				(= (is-at (second ?what)) hands)
 				(imply (exists (?o - open1) (= ?to ?o)) (is-open ?to))
 				(iff (= (at) fridge_place) (or (= ?to fridge) (= ?to fridge_counter)))
 			)
 		 :effect (and
 		 		(assign (is-at (first ?what)) ?to)
 		 		(assign (is-at (second ?what)) ?to)
 				(decrease (objects_taken) 2)
 				)
		; :observation (set_action (actionId put))
 			)


 (:action put
	 :parameters (?howmany - (number 1 2)  ?what - cput1 ?to - put2)
	 ; :duration (put (objectId ?what) (objectId ?to))
	 :precondition (and 
		 (take-pair ?what ?to)
		 (not (= ?what ?to))
		 (>= (objects_taken) ?howmany)
		(>= (is-at-num ?what hands) ?howmany)
		(imply (exists (?o - open1) (= ?to ?o)) (is-open ?to))
		(iff (= (at) fridge_place) (or 
						(= ?to fridge)
                  (= ?to fridge_counter)
						(exists (?t - take1)(and (= (is-at ?t) fridge) (= ?t ?to)))
						)
					)
		)
	 :effect (and 
	 		(assign (is-at-num ?what ?to) (+ (is-at-num ?what ?to) ?howmany))
			(assign (is-at-num ?what hands) (- (is-at-num ?what hands) ?howmany))
			(decrease (objects_taken) ?howmany)
			)
	; :observation (set_action (actionId put))
)


	
	(:action walk
		:parameters (?from ?to - walkl)
		; :duration (walk (objectId ?from) (objectId ?to))
		:precondition (and
			(= (at) ?from)
			(not (= ?from ?to))
			)
		:effect (assign (at) ?to)
		; :observation (set_action (actionId walk))
	)
	
	
	(:action turn_on
		:parameters (?what - turn_on1)
		; :duration (turn_on (objectId ?what))
		:precondition (and
			(not (is-on ?what))
			(= (at) counter_place)
			)
		:effect (is-on ?what)
		; :observation (set_action (actionId turn_on))
	) 
	

	(:action fill
		:parameters (?what - fill1 ?from - fill2  ?to - fill3)
		; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
		:precondition (and 
			(fill-triple ?what ?from ?to)
			(not (= ?from ?to))
			(or 
				(= (is-at ?from) hands)
				(= ?from tap)
			)
			(or 
				(= (is-at ?to) hands)
				(and (= ?to bowl) (= (is-at bowl) counter))
				(and (= ?to measuring_cup_s) (= (is-at measuring_cup_s) counter))
				(and (= ?to baking_pan) (or 
					(= (is-at baking_pan) counter)
					(= (is-at baking_pan) board))
				)
			)
			(or 
					(and
					(= ?to baking_pan)
;					(in butter ?to)
					(= ?what dough)
					(= bowl ?from)
					(stired ?from)
					(in brownie_mix ?from)
					(in water ?from)
					(in oil ?from)
					;(= (in-num egg ?from) 2)
)
				(in ?what ?from)
			)
		)
		:effect (and 
			(in ?what ?to)
			(not (in ?what ?from))
			(not (stired ?to))
			(not (is-clean hands))
			(when (and (= ?what dough) (= ?from bowl) (= ?to baking_pan)) (not (is-clean bowl)))
			)
		; :observation (set_action (actionId fill))
		)
		
		(:action fill
			:parameters (?what - pfill1 ?from - fill2  ?to - fill3 ?how - part)
			; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
			:precondition (and 
				(fill-triple ?what ?from ?to)
				(not (= ?from ?to))
				(or 
					(= (is-at ?from) hands)
					(= ?from tap)
				)
				(or 
					(= (is-at ?to) hands)
					(and (= ?to bowl) (= (is-at bowl) counter))
					(and (= ?to measuring_cup_s) (= (is-at measuring_cup_s) counter))
					(and (= ?to baking_pan) (or 
						(= (is-at baking_pan) counter)
						(= (is-at baking_pan) board))
					)
				)
				(or 
					(and
					(= ?what dough)
					(= bowl ?from)
					(stired ?from)
					(in brownie_mix ?from)
					(in water ?from)
					(in oil ?from)
					(= (in-num egg ?from) 2))
					(in ?what ?from)
				)
			)
			:effect (and 
				(partially-in ?what ?to)
				(not (stired ?to))
				(not (is-clean hands))
				)
			; :observation (set_action (actionId fill))
			)
			
			
		(:action fill
			:parameters (?what - cfill1 ?from - cofill2 ?to - fill3)
			; :duration (fill (objectId ?what) (objectId ?from) (objectId ?to))
			:precondition (and 
				(fill-triple ?what ?from ?to)
				(is-in ?what ?from)
				(>= (is-at-num ?from hands) 1)
				)
			:effect (and
				(decrease (is-at-num ?from hands) 1)
				(increase (is-at-num (empty-of ?from) hands) 1)
				(increase (in-num ?what ?to) 1)
				(not (stired ?to))
				(not (is-clean hands))
				)
			; :observation (set_action (actionId fill))
			)
			
	(:action clean
		:parameters (?what - clean1 ?with - clean2)
		; :duration (clean (objectId ?what) (objectId ?with))
		:precondition (and 
			(or
					(imply (= ?with towel) (= (is-at ?with) hands))
					(imply (= ?with paper_towel)(>= (is-at-num paper_towel hands) 1))
				)
				(not (is-clean ?what))
				)
		:effect (and
			(is-clean ?what))
		; :observation (set_action (actionId clean))
		)
		
		(:action clean
			:parameters (?what - clean1 ?with - clean2 ?how - part)
			; :duration (clean (objectId ?what) (objectId ?with))
			:precondition (and 
				(or
						(imply (= ?with towel) (= (is-at ?with) hands))
						(imply (= ?with paper_towel)(>= (is-at-num paper_towel hands) 1))
					)
					(not (is-clean ?what))
					)
			:effect (and
				(partially-is-clean ?what))
			; :observation (set_action (actionId clean))
			)
		
	(:action stir
		:parameters (?where - stir1 ?with - stir2)
		; :duration (stir (objectId ?where) (objectId ?with))
		:precondition (and
			(=(is-at ?with) hands)
			(or
			(=(is-at ?where) hands)
			(=(is-at ?where) counter)
			)
			(not (stired ?where))
			)
		:effect (and
			(stired ?where)
			(not (is-clean hands)))
		; :observation (set_action (actionId stir))
		)

	(:action stir
		:parameters (?where - stir1 ?with - stir2 ?how - part)
		; :duration (stir (objectId ?where) (objectId ?with))
		:precondition (and
			(=(is-at ?with) hands)
			(or
			(=(is-at ?where) hands)
			(=(is-at ?where) counter)
			)
			(not (stired ?where))
			)
		:effect (and
			(partially-stired ?where))
		; :observation (set_action (actionId stir))
		)
		
		(:action shake
			:parameters (?what - shake1)
			; :duration (shake (objectId ?what))
			:precondition (and
				(= (is-at ?what) hands)
				(< (shaken ?what) 3))
			:effect (increase (shaken ?what) 1)
			; :observation (set_action (actionId shake))
		)

	
	(:action other
		:irrational
		:parameters ()
		; :duration (other)
		:precondition ()
		:effect() 
		; :observation (set_action (actionId other))
	)
	
	(:action finish
		:irrational
		:parameters()
		:precondition (not finished)
		:effect (finished)
	)
)
